#include "descriptor/descriptor.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>       /* error definitions and routines */
#include <string.h>      /* string functions */

char *nome;
int i;

//attributi
 ITEM	vetro,nero,marrone,marrone_scuro,marrone_bulbo,marrone_cappello,
	rame,senape,rosso_mela,giallo_chitarra,
	bianco,carne[2],verde_camicia[2];
//superfici contesto
 ITEM	stanza,cavo,sgabello,
 	alloggio_lampadina[6],lampadina[6],
 	mela[7];
//superfici omini
 ITEM   omino_basso,scarpe[2],passante[5];
//strumenti
 ITEM chitarra_basso;
//identificativo universale
 ITEM   scene;


//per il questo lavaro
typedef struct m_item_attr {
  char nome[30];
  ITEM attrib;
} SUP_ATTR;
//SUP_ATTR[0] num di sup da differenziare e l'attributo generale
//SUP_ATTR[i] nome della sup. e suo attrub.
//questo vettore deve essere generato rispettando l'ordine delle sup nel .obj

ITEM read_obj_Multiple_attribute(char *obj_file,char *nome,SUP_ATTR *mult_attr){
	ITEM list;
	FILE *fpr;
	char *p=NULL;
	size_t n=0;
	int max_j=atoi(mult_attr[0].nome);
	printf("\n\nfile:'%s'\n",obj_file);
	printf("creo la struttura %s superfici da differenziare %d \n",nome,max_j);
	int i,surf_no,j=1; //j contatore vettore superficie_attributo 
			   //parte da uno perchè il primo elemento di questo vettore 
			  // rappresenta l'attributo generale
	char *comodo=calloc(100,1);
	if (!(fpr = fopen(obj_file,"r")))
		printf("errore dello stream: %s\n",strerror(errno));
	getline(&p, &n, fpr);	
	getline(&p, &n, fpr);
	surf_no=atoi(p); 
	printf("superfici da leggere :%d\n",surf_no);
	ITEM sup[surf_no];
	for (i=0; i<surf_no; i++) {
		getline(&p, &n, fpr);
		if(!i){
			strncpy(comodo,p,strlen(p)-1);
			sup[i]=read_nurbs(comodo);
			if (j<=max_j){
				if (!strcmp(comodo,mult_attr[j].nome)){
					set_attribute(sup[i],mult_attr[j].attrib);
					j++;//ordine delle superf. nel file obj
					//rispetta ordine del vettore mult_attr[j]
					}
			   	    else set_attribute(sup[i],mult_attr[0].attrib);
				}
			   else	set_attribute(sup[i],mult_attr[0].attrib);
			list = create_list(sup[i], nome);
			}
		 else{
			if (i == (surf_no-1))	strncpy(comodo,p,strlen(p));
			   else 		strncpy(comodo,p,strlen(p)-1);
			sup[i]=read_nurbs(comodo);
			if (j<=max_j){
				if (!strcmp(comodo,mult_attr[j].nome)){
					set_attribute(sup[i],mult_attr[j].attrib);
					j++;//ordine delle superf. nel file obj
					//rispetta ordine del vettore mult_attr[j]
					}
				     else set_attribute(sup[i],mult_attr[0].attrib);
				}
			   else set_attribute(sup[i],mult_attr[0].attrib);
			list = insert_in_list(list, sup[i]);
			}
		printf("%s caricata!...\n",comodo);	
		memset(comodo,0,100);
 		}
free(comodo);
return (list);
}

void background_light(void){
 set_background(0.676,0.861,0.953,TRUE);
 set_ambient_light(1,1,1,0.7);
		//pos x,y,z; color r,g,b ; intensity ;fade
//lampadine
 create_point_light(1.362,-6.7,9.7,1,1,1,2.5,15,"luce_lampadina_in");
 create_point_light(1.362,-6.7,8.7,1,1,1,1.5,15,"luce_lampadina_ext");
 create_point_light(1.37653,-5.5160,11.16,1,1,1,2.5,15,"luce_lampadina1_in");
 create_point_light(1.37653,-5.5160,10.16,1,1,1,1.5,15,"luce_lampadina1_ext");
 create_point_light(1.32800,-3.3,11.120,1,1,1,2.5,15,"luce_lampadina2_in");
 create_point_light(1.32800,-3.3,10.120,1,1,1,1.5,15,"luce_lampadina2_ext");
 create_point_light(1.210,0.360,10.94,1,1,1,2.5,15,"luce_lampadina3_in");
 create_point_light(1.210,0.360,9.94,1,1,1,1.5,15,"luce_lampadina3_ext");
 create_point_light(1.2,3.293,11.2,1,1,1,2.5,15,"luce_lampadina4_in");
 create_point_light(1.2,3.293,10.2,1,1,1,1.5,15,"luce_lampadina4_ext");
 create_point_light(1.226,5.173,10.020,1,1,1,1.5,15,"luce_lampadina5_in");
 create_point_light(1.226,5.173,9.020,1,1,1,1.5,15,"luce_lampadina5_ext");
//uomo
 create_point_light(20.2152,11.407,5,1,1,1,3.5,22,"luce_uomo");

}

void attribute(void){
  vetro = create_attribute("vetro");
		/* r , g, b,pa,pd  pa=capacità di riflettere luce ambiente
				   pd= proporzioni riflessione diffusa */
  set_color(vetro,1,1,1,1,0);
  set_reflectivity(vetro,0.24,2);
  set_transparency(vetro,1,0.90,2,0);

  bianco = create_attribute("bianco");
  set_color(bianco,1,1,1,0.5,0.5);
  set_reflectivity(bianco,0.5,1);

  rame = create_attribute("rame");
  set_color(rame,1,0.67843,0.0353,0.5,0.5);
  set_reflectivity(rame,0.3,1);

  nero = create_attribute("nero");
  set_color(nero,0,0,0,0.5,0.5);
  set_reflectivity(nero,0.06,0.06);//luce speculare

  marrone = create_attribute("marrone");
  set_color(marrone,0.8196,0.255,0.105882,0.3,0.4);
  // notare l'assenza della funzione set_reflectivity

  senape  = create_attribute("senape");
  set_color(senape,0.8470,0.6745,0.0470,0.3,0.4);
  set_reflectivity(senape,0.04,0.04);
  
  giallo_chitarra  = create_attribute("giallo_chitarra");
  set_color(giallo_chitarra,1,0.6745,0.0470,0.64,0.4);
  set_reflectivity(giallo_chitarra,0.04,0.04);

  rosso_mela  = create_attribute("rosso_mela");
  set_color(rosso_mela,0.92941,0.25098,0.043137,0.3,0.4);
 // set_reflectivity(rosso_mela,0.04,0.1); da rivedere

  marrone_scuro  = create_attribute("marrone_scuro");
  set_color(marrone_scuro,0.27843,0.08627,0.015686,0.3,0.4);

  carne[0]  = create_attribute("carne");
  set_color(carne[0],1,0.76475882,0.635294,0.95,0.250);
  set_reflectivity(carne[0],0.04,1);

  carne[1]  = create_attribute("labbra");
  set_color(carne[1],1,0.2862745,0.2862745,0.95,0.250);
  set_reflectivity(carne[1],0.04,1);

  marrone_bulbo  = create_attribute("marrone_bulbo");
  set_color(marrone_bulbo,0.33333,0.22196,0.10196,0.95,0.4);
  set_reflectivity(marrone_bulbo,0.05,1);

  marrone_cappello  = create_attribute("marrone_cappello");
  set_color(marrone_cappello,0.6745,0.372549,0.10196,0.95,0.4);
  set_reflectivity(marrone_cappello,0.05,1);

  verde_camicia[0]  = create_attribute("verde_camicia");
  set_color(verde_camicia[0],0.31764,0.45490,0.11764,0.3,0.4);

  verde_camicia[1]  = create_attribute("fantasia_camicia");
  set_color(verde_camicia[1],0.172549,0.172549,0.09803,0.3,0.4);	
}

void contesto(void){
//stanza
  stanza = read_nurbs("stanza.dbe");
  set_translate(stanza,-0.1509724,-0.146164,-0.040942);
  set_attribute(stanza,marrone);
  set_scale(stanza,70,20,16);
  set_translate(stanza,20,-0.000001,11.59);
// bump mapping con foto del mio soffitto salvata in scala di griggio  rimappata su un sottodominio U_V e messo il flag a 1 per lasciare alla lib. descriptor il resto l'effetto di bump e' localizzato alle zone dove le fonti luminose hanno influenza
set_bump_texture(stanza,marrone,"./textures/bump_assi.hr",3.0e-01,6.0e-01,8.3e-01,9.3e-01,1,0.05,0.4);


//cavo :guaina del filo elettrico con innesti
  cavo = read_obj("cavo_elettrico.obj", "cavo");
  set_attribute(cavo,nero);
  set_scale(cavo,1.1,1.2,1.1);
  set_translate(cavo,0,1.626750,11.77657);

// alloggio dove avvitare la lampadina
  alloggio_lampadina[0] = read_nurbs("alloggio_lampadina.db");
  set_scale(alloggio_lampadina[0],0.6,0.6,0.6);
  set_translate(alloggio_lampadina[0],0.00001,-0.000935,-0.3181162);
  set_y_rotate(alloggio_lampadina[0],180,1);
  set_attribute(alloggio_lampadina[0],nero);

// lampadina
SUP_ATTR mult_attr[10];
  strcpy(mult_attr[0].nome,"1");
  mult_attr[0].attrib=rame;
  strcpy(mult_attr[1].nome,"vetro.db");
  mult_attr[1].attrib=vetro;

  lampadina[0] = read_obj_Multiple_attribute("lampadina.obj","lampadina",mult_attr);
  set_translate(lampadina[0],0,0,-0.3129557);
  set_y_rotate(lampadina[0],180,1);
  set_scale(lampadina[0],0.6,0.6,0.6);
   //copie di lampadina e alloggio
  nome=calloc(30,1);
  for (i=1;i<6;i++){
	sprintf(nome,"alloggio_lampadina%d",i);
	printf("lampadina->%s ",nome);
	alloggio_lampadina[i] = create_copy(alloggio_lampadina[0], nome);
	memset(nome,0,30);
	sprintf(nome,"lampadina%d",i);
	lampadina[i] = create_copy(lampadina[0], nome);
	printf(",%s\n",nome);
	memset(nome,0,30);
	}
  //traslo nei punti di innesto
  set_translate(alloggio_lampadina[0],1.362,-6.7,10.1);
  set_translate(lampadina[0],1.362,-6.7,9.8);//-0.3 diff
  set_translate(alloggio_lampadina[1],1.37653,-5.516,11.6);
  set_translate(lampadina[1],1.37653,-5.516,11.3);
  set_translate(alloggio_lampadina[2],1.328,-3.3,11.42);
  set_translate(lampadina[2],1.328,-3.3,11.12);
  set_translate(alloggio_lampadina[3],1.21,0.36,11.4);
  set_translate(lampadina[3],1.21,0.36,11.1);
  set_translate(alloggio_lampadina[4],1.2,3.293,11.50);
  set_translate(lampadina[4],1.2,3.293,11.20);
  set_translate(alloggio_lampadina[5],1.226,5.17375,10.32);
  set_translate(lampadina[5],1.226,5.17375,10.02);

//sgabello
  sgabello= read_obj("sgabello.obj","sgabello");
  set_attribute(sgabello,senape);
  set_translate(sgabello,-0.0479184,0.01304,0.6015183);
  set_z_rotate(sgabello,85,1);
  set_scale(sgabello,3,3,2.35);
  set_translate(sgabello,6.4,-0.8,1.50);

//mele
  strcpy(mult_attr[0].nome,"1");
  mult_attr[0].attrib=rosso_mela;
  strcpy(mult_attr[1].nome,"gambo.db");
  mult_attr[1].attrib=marrone_scuro;
  mela[0] = read_obj_Multiple_attribute("mela.obj","mela",mult_attr);
  set_translate(mela[0],0,0,-0.2872326);
  set_scale(mela[0],0.8,0.8,0.8);
  for (i=1;i<7;i++){
	sprintf(nome,"mela%d",i);
	printf("mela->%s\n",nome);
	mela[i] = create_copy(mela[0], nome);
	memset(nome,0,30);
	}
  set_z_rotate(mela[0],180,1);
  set_translate(mela[0],7.8,-6.3,0.4);
  set_z_rotate(mela[1],180,1);
  set_translate(mela[1],9.6,-4.3,0.4);
  set_y_rotate(mela[2],-90,1);
  set_translate(mela[2],9.5,-0.7,0.31);
  set_translate(mela[3],6,1.9,0.4);
  set_y_rotate(mela[4],-90,1);
  set_translate(mela[4],7.8,3.34,0.31);
  set_translate(mela[5],5.4,6.6,0.4);
  set_y_rotate(mela[6],-90,1);
  set_translate(mela[6],-1.1,7.2,0.31);
}

void list_contesto(void){
  scene = create_list(stanza, "scene");
  scene = insert_in_list(scene,cavo);
  for (i=0;i<6;i++){
	scene = insert_in_list(scene,alloggio_lampadina[i]);
  	scene = insert_in_list(scene,lampadina[i]);
  	}
  scene = insert_in_list(scene,sgabello);
  for (i=0;i<7;i++){
  	scene = insert_in_list(scene,mela[i]);
  	}
printf("\n contesto caricato\n");
}


void omini(void){
//omino_basso primo piano a sinistra
SUP_ATTR mult_attr[33];
  strcpy(mult_attr[0].nome,"32");
  mult_attr[0].attrib=carne[0];
  strcpy(mult_attr[1].nome,"sclera_sx.dbe");
  mult_attr[1].attrib=bianco;
  strcpy(mult_attr[2].nome,"iride_sx.db");
  mult_attr[2].attrib=marrone_bulbo;
  strcpy(mult_attr[3].nome,"sclera_dx.dbe");
  mult_attr[3].attrib=bianco;
  strcpy(mult_attr[4].nome,"iride_dx.db");
  mult_attr[4].attrib=marrone_bulbo;
  strcpy(mult_attr[5].nome,"baffo_sx.db");
  mult_attr[5].attrib=nero;
  strcpy(mult_attr[6].nome,"baffo_dx.db");
  mult_attr[6].attrib=nero;
  strcpy(mult_attr[7].nome,"labbra.db");
  mult_attr[7].attrib=carne[1];
  strcpy(mult_attr[8].nome,"sopracciglia_sx.db");
  mult_attr[8].attrib=marrone_bulbo;
  strcpy(mult_attr[9].nome,"sopracciglia_dx.db");
  mult_attr[9].attrib=marrone_bulbo;
  strcpy(mult_attr[10].nome,"capelli.db");
  mult_attr[10].attrib=marrone_bulbo;
  strcpy(mult_attr[11].nome,"cappello.dbe");
  mult_attr[11].attrib=marrone_cappello;
  strcpy(mult_attr[12].nome,"fascia_cappello.db");
  mult_attr[12].attrib=marrone_bulbo;
  strcpy(mult_attr[13].nome,"gamba_sx.db");
  mult_attr[13].attrib=marrone;
  strcpy(mult_attr[14].nome,"gamba_dx.db");
  mult_attr[14].attrib=marrone;
  strcpy(mult_attr[15].nome,"maglia.dbe");
  mult_attr[15].attrib=verde_camicia[0];
  strcpy(mult_attr[16].nome,"colletto_maglia.db");
  mult_attr[16].attrib=verde_camicia[1];
  strcpy(mult_attr[17].nome,"cintura.db");
  mult_attr[17].attrib=senape;
  strcpy(mult_attr[18].nome,"braccio_sx.db");
  mult_attr[18].attrib=verde_camicia[0];
  strcpy(mult_attr[19].nome,"polsino_sx.db");
  mult_attr[19].attrib=bianco;
  strcpy(mult_attr[20].nome,"braccio_dx.db");
  mult_attr[20].attrib=verde_camicia[0];
  strcpy(mult_attr[21].nome,"polsino_dx.db");
  mult_attr[21].attrib=bianco;
  strcpy(mult_attr[22].nome,"unghia_pollice_dx.db");
  mult_attr[22].attrib=vetro;
  strcpy(mult_attr[23].nome,"unghia_indice_dx.db");
  mult_attr[23].attrib=vetro;
  strcpy(mult_attr[24].nome,"unghia_medio_dx.db");
  mult_attr[24].attrib=vetro;
  strcpy(mult_attr[25].nome,"unghia_anulare_dx.db");
  mult_attr[25].attrib=vetro;
  strcpy(mult_attr[26].nome,"unghia_mignolo_dx.db");
  mult_attr[26].attrib=vetro;
  strcpy(mult_attr[27].nome,"unghia_pollice_sx.db");
  mult_attr[27].attrib=vetro;
  strcpy(mult_attr[28].nome,"unghia_indice_sx.db");
  mult_attr[28].attrib=vetro;
  strcpy(mult_attr[29].nome,"unghia_medio_sx.db");
  mult_attr[29].attrib=vetro;
  strcpy(mult_attr[30].nome,"unghia_anulare_sx.db");
  mult_attr[30].attrib=vetro;
  strcpy(mult_attr[31].nome,"unghia_mignolo_sx.db");
  mult_attr[31].attrib=vetro;



  omino_basso= read_obj_Multiple_attribute("omino_basso.obj","omino_basso",mult_attr);
  set_translate(omino_basso,-0.2046175,-0.029236,-0.9883055);
  set_z_rotate(omino_basso,-10,1);
  set_scale(omino_basso,0.6,0.7,0.6);
  set_translate(omino_basso,6.78,3.83,3.75);
 //scarpe omino_basso  
  scarpe[0] = read_nurbs("scarpa_sx.db");
  set_attribute(scarpe[0],marrone_scuro);
  set_translate(scarpe[0],-0.07225,0.0191845,-0.1485872);
  set_z_rotate(scarpe[0],-100,1);
  set_scale(scarpe[0],1.2,2.5,1.6);
  set_translate(scarpe[0],7.06,2.71,0.265);
  scarpe[1] = read_nurbs("scarpa_dx.db");
  set_attribute(scarpe[1],marrone_scuro);
  set_translate(scarpe[1],0.07225,0.0191845,-0.14271680);
  set_z_rotate(scarpe[1],-77,1);
  set_y_rotate(scarpe[1],5,1);
  set_scale(scarpe[1],1.2,2.5,1.6);
  set_translate(scarpe[1],6.85,4.85,0.272);
  omino_basso=insert_in_list(omino_basso,scarpe[0]);
  omino_basso=insert_in_list(omino_basso,scarpe[1]);

//passanti cintura omino_basso
  passante[0] = read_nurbs("passante.db");
  set_attribute(passante[0],marrone);
/*set_translate(passante[0],1.847056,-0.01131,-0.444324); trasla nel punto (0,0,0) invece
traslo nel punto P(1.847056,-0.01131,0) per eseguire rotazioni sulla'asse z con
baricentro in quel punto*/
  set_translate(passante[0],0,0,-0.444324);
  nome=calloc(30,1);
  for (i=1;i<6;i++){
	sprintf(nome,"passante%d",i);
	printf("pantaloni->%s \n",nome);
	passante[i] = create_copy(passante[0], nome);
	memset(nome,0,30);
	}
  set_translate(passante[0],7.42,4.05,3.42);
  set_z_rotate(passante[1],-45,1);
  set_translate(passante[1],7.54,4.05,3.42);
  set_z_rotate(passante[2],45,1);
  set_translate(passante[2],6.986,4.05,3.39);
  set_z_rotate(passante[3],-150,1);
  set_translate(passante[3],6.34,3.582,3.42);
  set_z_rotate(passante[4],150,1);
  set_translate(passante[4],6.05,3.62,3.42);
  for (i=0;i<5;i++)
	omino_basso = insert_in_list(omino_basso,passante[i]);
  printf("	omino_basso completato\n");

}


void list_omini(void){
  scene = insert_in_list(scene,omino_basso);
}


void strumenti(void){
//chitarra uomo_basso
SUP_ATTR mult_attr[7];
  strcpy(mult_attr[0].nome,"6");
  mult_attr[0].attrib=nero;
  strcpy(mult_attr[1].nome,"asta.db");
  mult_attr[1].attrib=marrone_scuro;
  strcpy(mult_attr[2].nome,"attacco_corde.db");
  mult_attr[2].attrib=marrone_scuro;
  strcpy(mult_attr[3].nome,"cassa.dbe");
  mult_attr[3].attrib=marrone_bulbo;
  strcpy(mult_attr[4].nome,"risonanza.db");
  mult_attr[4].attrib=marrone_bulbo;
  strcpy(mult_attr[5].nome,"cassa_frontale.db");
  mult_attr[5].attrib=giallo_chitarra;
  strcpy(mult_attr[6].nome,"cassa_front_int.db");
  mult_attr[6].attrib=giallo_chitarra;

  chitarra_basso=read_obj_Multiple_attribute("chitarra_basso.obj","chitarra_basso",mult_attr);
  set_translate(chitarra_basso,0,0.2081144,-0.1257764);
  set_scale(chitarra_basso,5.3,5.7,4.3);
  set_x_rotate(chitarra_basso,-140,1);
  set_translate(chitarra_basso,0,0.2717175,0.015346);
  set_y_rotate(chitarra_basso,30,1);
  set_translate(chitarra_basso,0.265354,0,0.2319482);
  set_z_rotate(chitarra_basso,15,1);
  set_translate(chitarra_basso,7.9,4.38,4.4);
printf("	chitarra completata\n");

}


void list_strumenti(void){
  scene = insert_in_list(scene,chitarra_basso);
}

int main(void) {
 background_light();
 attribute();
 contesto();
 list_contesto();
 omini();
 list_omini();
 strumenti();
 list_strumenti();
 save_scene("botero.md","scene_botero",scene);
return(0);
}
